## Mash Sketches Quick Start

gopher-smash provides data structures to load
and manipulate Mash sketches.

This quick start covers how to load Mash sketches.
For more information about the sketches and an 
explanation of the Mash sketch format, see
[MashSketches.md](MashSketches.md).


### Loading a Mash Sketch (JSON)

Load a Mash MinHash sketch that was dumped in JSON
format using `mash info -d` by calling the
`MashSketchesFromFile()` function:

```go
package main

import (
    gosh "git.charlesreid1.com/charlesreid1/gopher-smash
)

func main() {

	json_file := "genome1.fna.msh.json"
	minhashCollection, err := gosh.LoadMashJson(json_file)

}
```

Behind the scenes:
- load Json data into data structure for Json
- process each sketch in the Json data
- return the sketches

gopher-smash does not provide a way to load Mash Capnp formatted
MinHash sketches directly.

Use `mash info -d` to create a JSON instead.


### Printing

To view information about each minhash sketch:

```go
package main

import (
    gosh "git.charlesreid1.com/charlesreid1/gopher-smash
)

func main() {

	json_file := "genome1.fna.msh.json"
	minhashCollection, err := gosh.LoadMashJson(json_file)
    minhash0 := minhashCollection[0]
    for _,sig := range minhash0.Signatures() {
        fmt.Println(sig)
    }

}
```


### Manipulating

TBD

The MinHash sketches can be modified in memory once loaded.
The representation of each MinHash sketch can be modified
(downsampled, header info changed, etc.) and changes updated
on disk to reflect changes.

(Note: storing trees using files.)


